<?php
/*
Plugin Name: FusionHQ for WordPress
Plugin URI: http://www.fusionhq.com
Description: Synchronize data between FusionHQ and Wordpress.
Version: 1.0.5
Author: FusionHQ
Author URI: http://www.fusionhq.com
License: GPL2
*/
/*  Copyright 2010  FusionHQ  (email : developer@fusionhq.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

require_once (ABSPATH . WPINC . '/registration.php');

function vardump($arg)
{
    echo "<pre>";
    var_dump($arg);
    echo "</pre>";
}

if (!function_exists('get_user_meta')) {

    function get_user_meta($userid, $metakey)
    {
        return get_usermeta($userid, $metakey);
    }

}

function array_to_set($arr, $delimeter = ",")
{
    if (is_array($arr) && count($arr) > 0) {
        return implode($delimeter, $arr);
    }
    return '';
}

function set_to_array($set, $delimeter = ",")
{
    if (is_string($set) && $set != '') {
        return explode($delimeter, $set);
    }
    return array();
}

function is_checked($val1, $val2)
{
    if (!isset($val2))
        return false;

    if (is_string($val2))
        return ($val1 === $val2);

    if (is_array($val2) && count($val2) > 0) {
        return in_array($val1, $val2);
    }
    return false;
}

function pair_str_to_array($str, $separator = '=', $delim = ',')
{
    $elems = explode($delim, $str);
    foreach ($elems as $elem => $val) {
        $val = trim($val);
        $nameVal[] = explode($separator, $val);
        $separateindex = strpos($val, $separator);
        $key = substr($val, 0, $separateindex);
        $exactval = substr($val, $separateindex + 1);
        $arr[$key] = $exactval;
    }
    return $arr;
}

function pair_array_to_str($arr, $seperator = '=', $delim = ',')
{
    if (!is_array($arr) || count($arr) == 0) {
        return '';
    }
    $piecearray = array();
    foreach ($arr as $key => $val) {
        $piecearray[] = $key . $seperator . $val;
    }
    return implode($delim, $piecearray);
}

function validate_delay($registerdate, $type = 'NONE', $period = 0, $unit = 'D',
    $release = 0)
{
    switch ($type) {
        case "PERIOD":
            if ($registerdate == 0)
                return false;
            $refdate = $registerdate;
            switch ($unit) {
                case "D":
                    $releasedate = $refdate + $period * 60 * 60 * 24;
                    break;
                case "W":
                    $releasedate = $refdate + $period * 60 * 60 * 24 * 7;
                    break;
                case "M":
                    $releasedate = $refdate + $period * 60 * 60 * 24 * 30;
                    break;
                case "Y":
                    $releasedate = $refdate + $period * 60 * 60 * 24 * 365;
                    break;
                default;
                    $releasedate = $refdate;
                    break;
            }
            $time_diff = $releasedate - $registerdate;
            return ($time_diff < 0);
        case "DATE":
            $time_diff = $release - $registerdate;
            return ($time_diff < 0);
        case "NONE":
            return true;
        default:
            return false;
    }
    return false;
}

function validate_privilege($memship_id, $privilege = '')
{
    if ($privilege == '') {
        return true;
    } else {
        $privilegeArr = set_to_array($privilege, '|');
        if (is_checked($memship_id, $privilegeArr)) {
            return true;
        }
    }
    return false;
}

function validate_access($memship_json, $privilege, $delaytype, $period, $unit, $releasedate)
{
    $memshipArr = json_decode($memship_json);
    if (count($memshipArr) > 0) {
        foreach ($memshipArr as $memship) {
            if (validate_privilege($memship->id, $privilege) && validate_delay($memship->
                registerdate, $delaytype, $period, $unit, $releasedate)) {
                return true;
            }
        }
    } else {
        if (validate_privilege(0, $privilege) && validate_delay(0, $delaytype, $period,
            $unit, $releasedate)) {
            return true;
        }
    }
    return false;
}

function fhq_server_request($apimail, $apikey, $todo, $params = null)
{
	$debug = $_SERVER['HTTP_HOST'] == "localhost";
	if($debug){
    	$url = "https://localhost/fusionhq/index.php";
	}else{
		$url = "https://www.fusionhq.com/index.php";	
	}
    $port = "443";

    $url_parsed = parse_url($url);
    $sock = @fsockopen("ssl://" . $url_parsed['host'], $port, $err_num, $err_str, 30);
    if (!$sock) {
        echo $err_num;
        echo $err_str;
        die("<br>Failed\r\n\r\nCould not connect to {$url_parsed['scheme']}://{$url_parsed['host']} on the port {$port} !");
    }

    $apiemail = $apimail;
    $apikey = $apikey;

    $post_string = "act=api" . "&todo={$todo}" . "&apiemail={$apiemail}" . "&apikey={$apikey}";

    if (is_array($params)) {
        foreach ($params as $key => $val) {
            $post_string .= "&{$key}={$val}";
        }
    }

    fputs($sock, "POST $url_parsed[path] HTTP/1.1\r\n");
    fputs($sock, "Host: $url_parsed[host]\r\n");
    fputs($sock, "Content-type: application/x-www-form-urlencoded\r\n");
    fputs($sock, "Content-length: " . strlen($post_string) . "\r\n");
    fputs($sock, "Connection: close\r\n\r\n");
    fputs($sock, $post_string . "\r\n\r\n");

    while (!feof($sock)) {
        $contents .= @fgets($sock);
    }
    fclose($sock);

    $data = explode("\r\n\r\n", $contents);
    if (preg_match("/Transfer-Encoding: chunked/", $data[0], $matches)) {
        $unchunked = unchunk_http11($data[1]);
        $returnvar = json_decode($unchunked);
    } else {
        $returnvar = json_decode($data[1]);
    }

    if ($returnvar == null)
        return $data[1];
    return $returnvar;
}

function unchunk_http11($data)
{
    $fp = 0;
    $outData = "";
    while ($fp < strlen($data)) {
        $rawnum = substr($data, $fp, strpos(substr($data, $fp), "\r\n") + 2);
        $num = hexdec(trim($rawnum));
        $fp += strlen($rawnum);
        $chunk = substr($data, $fp, $num);
        $outData .= $chunk;
        $fp += strlen($chunk);
    }
    return $outData;
}

function fhq_user_login($user_login)
{
    if ($user_login == "")
        return;

    $username = $_POST['log'];
    $password = $_POST['pwd'];

    $apiemail = get_option('fhq_account');
    $apikey = get_option('fhq_apikey');
    $memsite = get_option('fhq_select_memsite');

    $user_id = username_exists($username);
    $wp_user_level = get_user_meta($user_id, 'wp_user_level', true);

    if ($wp_user_level == 10) {
        if ($_SESSION['redirect'] != null) {
            $_SESSION['force_redirect'] = true;
        }
        return;
    }

    if ($user_id == null) {
        $returnvar = fhq_server_request($apiemail, $apikey, "loginmemsite", array("username" =>
            $username, "password" => $password, "memsite" => $memsite));
        $success = $returnvar->success;
        $username = $returnvar->username;
        $email = $returnvar->email;
        $fname = $returnvar->fname;
        $lname = $returnvar->lname;

        if ($success == true) {
            //add user.
            $user_id = username_exists($username);
            if (!$user_id) {
                $user_id = wp_create_user($username, $password, $email);
                if (is_wp_error($user_id))
                    echo $user_id->get_error_message();
            }
            //add user data form fusionHQ to wordpress database.
            $user_id = username_exists($username);
            update_user_meta($user_id, "first_name", $fname);
            update_user_meta($user_id, "last_name", $lname);

            $memshipArray = array();
            foreach ($returnvar->memship as $val) {
                $tmp["id"] = (int)$val->id;
                $tmp["name"] = $val->name;
                $tmp["registerdate"] = (int)strtotime($val->registerdate);
                $tmp["expiredate"] = (int)strtotime($val->expiredate);
                $memshipArray[] = $tmp;
            }
            $json = json_encode($memshipArray);
            update_user_meta($user_id, "_fhq_memship", $json);
            $_SESSION['memship'] = get_user_meta($user_id, "_fhq_memship", true);
        } else {
            echo "<div id='message' class='updated fade'><p><strong><font color='#FF0000'>FusionHQ Error Message :</strong> " .
                $returnvar->message . "</font></p></div>";
            return;
        }
    } else {
        $user = get_userdata($user_id);
        if (wp_check_password($password, $user->user_pass, $user->ID)) {
            if (get_user_meta($user_id, "_fhq_memship", true) == null) {
                $returnvar = fhq_server_request($fhq_account, $fhq_apikey, "memlevel_list");
                if ($returnvar->success) {
                    $memshipArray = array();
                    foreach ($returnvar->memship as $val) {
                        $tmp["id"] = (int)$val->id;
                        $tmp["name"] = $val->name;
                        $tmp["registerdate"] = (int)strtotime($val->registerdate);
                        $tmp["expiredate"] = (int)strtotime($val->expiredate);
                        $memshipArray[] = $tmp;
                    }
                    $json = json_encode($memshipArray);
                    update_user_meta($user_id, "_fhq_memship", $json);
                    $_SESSION['memship'] = get_user_meta($user_id, "_fhq_memship", true);
                }
            } else {
                $_SESSION['memship'] = get_user_meta($user_id, "_fhq_memship", true);
            }
        } else {
            return;
        }
    }

    if ($_SESSION['redirect'] != null) {
        $_SESSION['force_redirect'] = true;
    }
}

function fhq_save_redirect()
{
    if ($_GET['redirect'] != null)
        $_SESSION['redirect'] = $_GET['redirect'];
}

function fhq_force_redirect($location)
{
    if ($_SESSION['force_redirect']) {
        $redirect = $_SESSION['redirect'];
        unset($_SESSION['force_redirect']);
        unset($_SESSION['redirect']);
        remove_filter('wp_redirect', 'fhq_force_redirect');
        return ($redirect);
    }

    return $location;
}

function fhq_session_init()
{
    session_start();
    global $current_user;
    get_currentuserinfo();
    $_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);
    $_SESSION['is_validate'] = false;
}

function fhq_session_destroy()
{
    $sessin_id = session_id();
    if (!empty($session_id)) {
        session_destroy();
    }
}

// warn user if verification is not complete yet.
function fhq_admin_warnings()
{
    if (!get_option('fhq_account') || !get_option('fhq_apikey') || !get_option('fhq_validation') ||
        get_option('fhq_account') == '' || get_option('fhq_apikey') == '' || get_option
        ('fhq_validation') == '' || get_option('fhq_validation') == 0) {
        echo "
			<div id='fqh-warning' class='updated fade'><p><strong>" . __('FusionHQ API is almost ready.') .
            "</strong> " . sprintf(__('You must <a href="%1$s">verify your FusionHQ API Key</a> for it to work.<br /><br /> If you do not already have a FusionHQ account please go to <a href="http://www.fusionhq.com" target="_blank">www.FusionHQ.com</a> to create one now.'),
            "options-general.php?page=fusionhq-api-option") . "</p></div>
		";
    }
}

// create table when this activate this plugin.
function fhq_db_install()
{
    global $wpdb;
    $table_name = $wpdb->prefix . "fhq_memlevel";
    if ($wpdb->get_var("show tables like '$table_name'") != $table_name) {

        $sql = "CREATE TABLE " . $table_name . " (
			id bigint(11) NOT NULL AUTO_INCREMENT PRIMARY KEY,
			memlevel_id bigint(11) NOT NULL,
			memlevel_name VARCHAR( 64 ) NOT NULL
			)ENGINE=MyISAM  DEFAULT CHARSET=utf8;
		";

        require_once (ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
    }

	$table_name = $wpdb->prefix . "fhq_unique";
    if ($wpdb->get_var("show tables like '$table_name'") != $table_name) {

        $sql = "CREATE TABLE " . $table_name . " (
			unique_id VARCHAR(128) NOT NULL PRIMARY KEY,
			first_name text NOT NULL,
			last_name text NOT NULL,
			email text NOT NULL,
			email_list text NOT NULL,
			current_transaction text NOT NULL,
			transaction_list text NOT NULL,
			product_list text NOT NULL,
			memlevel_list text NOT NULL
			)ENGINE=MyISAM  DEFAULT CHARSET=utf8;
		";

        require_once (ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
    }


    add_option('fhq_account', '');
    add_option('fhq_apikey', '');
    add_option('fhq_source', '');
    add_option('fhq_validation', '0');
    add_option('fhq_select_memsite', '0');
	add_option('fhq_select_process', '0');
    add_option('fhq_memsite', '');
	add_option('fhq_process', '');
	add_option('fhq_memsite_secretkey','');
	add_option('fhq_process_secretkey','');

    // Need to enable xml_rpc value
    update_option('enable_xmlrpc', '1');
    
	$init_post = array(
		'post_type' => 'page',		   
		'post_title' => 'FusionHQ Width Detection',
		'post_content' => '<div id="fhq-width-dectection">
	<div id="fhq-width-notify" style="font-family: monospace;font-size: 13px;font-weight: normal;color: #D00;background-color: #FFC;border: dashed 1px #C00;padding: 5px;">This line supposes to show your theme width when you View Page. If not, please enable JavaScript for your browser.</div>
	<script type="text/javascript">
		jQuery(document).ready(function() {
			jQuery("#fhq-width-notify").html( "Your content width is approximately ~ <strong>" + Math.floor(jQuery("#fhq-width-dectection").width()/10)*10 + "</strong> px." );
		});
	</script>
</div>',
		'post_status' => 'private',
		'comment_status' => 'closed',
		'ping_status' => 'closed',
		'post_author' => 1
	);
	
	$init_post_ID = wp_insert_post($init_post);
	
	update_option('fhq_init_page_id',$init_post_ID);
}

register_activation_hook(__file__, 'fhq_db_install');

// uninstall plugin and delete table from database.
function fhq_db_uninstall()
{
	if(get_option('fhq_source')=='PROCESS'){
		$source = 'p';
	}else if(get_option('fhq_source')=='MEMSITE'){
		$source = 'm';
	}else{
		$source = 'all';	
	}
	
	$params = array(
		"memsite" => get_option('fhq_select_memsite'),
		"process" => get_option('fhq_select_process'),
		"source" => $source 
	);    
	$returnvar = fhq_server_request($fhq_account, $fhq_apikey, "deactivate", $params);
	
	global $wpdb;
    $table_name = $wpdb->prefix . "fhq_memlevel";
    $sql = "DROP TABLE IF EXISTS " . $table_name;
    $e = $wpdb->query($sql);
	
	$table_name = $wpdb->prefix . "fhq_unique";
    $sql = "DROP TABLE IF EXISTS " . $table_name;
    $e = $wpdb->query($sql);

    $table_name = $wpdb->prefix . "postmeta";
    $sql = "DELETE FROM " . $table_name . " WHERE meta_key LIKE '_fhq_%';";
    $e = $wpdb->query($sql);

    $table_name = $wpdb->prefix . "usermeta";
    $sql = "DELETE FROM " . $table_name . " WHERE meta_key LIKE '_fhq_%';";
    $e = $wpdb->query($sql);
	
	delete_option('fhq_account');
    delete_option('fhq_apikey');
    delete_option('fhq_source');
    delete_option('fhq_validation');
    delete_option('fhq_select_memsite');
	delete_option('fhq_select_process');
    delete_option('fhq_memsite');
	delete_option('fhq_process');
	delete_option('fhq_memsite_secretkey');
	delete_option('fhq_process_secretkey');
    
    wp_delete_post(get_option('fhq_init_page_id'));
    
    delete_option('fhq_init_page_id');
}

register_deactivation_hook(__file__, 'fhq_db_uninstall');

function fhq_plugins_menu()
{
    add_options_page('FusionHQ API Settings', 'FusionHQ API', 'manage_options', 'fusionhq-api-option', 'fhq_plugin_options');
}

function fhq_plugin_options()
{
    echo '<div class="wrap">';
    include_once "fusionpress_config.php";
    echo '</div>';
}

function fhq_customfield()
{
    if (!is_admin()) {
        return false;
    }
	
	if(get_option('fhq_validation') != 1){
		return false;
	}
	
    echo '<div class="wrap">';
    include_once "fusionpress_customfield.php";
    echo '</div>';
}

function fhq_get_unique($unique_id){
	global $wpdb;
	
	$result = $wpdb->get_row("Select * from ".$wpdb->prefix."fhq_unique where unique_id = '".$unique_id."' ");
	
	return $result;
}

function fhq_update_unique($unique_id,$filed,$value){
	global $wpdb;
	
	$result = $wpdb->get_row("Select * from ".$wpdb->prefix."fhq_unique where unique_id = '".$unique_id."' ");
	
	if($result != NULL){
		$wpdb->update( 'wp_fhq_unique', array( $filed => $value), array( 'unique_id' => $unique_id ), array( '%s' ), array( '%s' ) );
		return true;
	}else{
		return "unique_id : ".$unique_id." not found. update failed.";
	}
	
}

function fhq_unique_indentification(){
	$unique_id = $_SESSION['fhq_unique_id'];
	
	if(!isset($_SESSION['fhq_unique_id'])){
		if(!isset($_COOKIE['fhq_unique_id'])){
			$fhq_unique_id = uniqid();
			setcookie("fhq_unique_id", $fhq_unique_id, time()+3600*24*30*36);
			$_SESSION['fhq_unique_id'] = $fhq_unique_id;
			//TODO : send unique_id to FHQ
			
		}else{
			$_SESSION['fhq_unique_id'] = $_COOKIE['fhq_unique_id'];
		}
	}
}

/*
function fhq_validate_access_action($post)
{
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10) {
        $_SESSION['is_validate'] = true;
        return;
    }

    $_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);

    $access_level = get_post_meta($post->ID, '_fhq_access_level', true);
    if ($access_level == 'PRIVATE') {
        $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
    } else {
        $privilege = '';
    }
    $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
    $period = get_post_meta($post->ID, '_fhq_delay_period', true);
    $unit = get_post_meta($post->ID, '	_fhq_delay_periodunit', true);
    if ($delaytype == "NONE") {
        $releasedate = 0;
    } else {
        $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
    }

    $_SESSION['is_validate'] = validate_access($_SESSION['memship'], $privilege, $delaytype,
        $period, $unit, $releasedate);
    
 
    if (!$_SESSION['is_validate']) {
	     $post->post_title = '';
		$post->comment_status = 'closed';
		$post->ping_status    = 'closed';
    }
    
}
*/

function fhq_dovalidate_post($post){
	echo $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
}

function fhq_validate_access_element($privilege, $delaytype, $period, $unit, $releasedate)
{
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10) {
        $_SESSION['is_validate'] = true;
        return;
    }
	
    $_SESSION['is_validate'] = validate_access($_SESSION['memship'], $privilege, $delaytype,
        $period, $unit, $releasedate);
}

function fhq_validate_access_filter($content)
{
    if ($_SESSION['is_validate']) {
        return $content;
    } else {
        return 'You do not have permission to view this content.<br>If you are a member please click <a href="' . (get_option
            ('siteurl') . "/" . "wp-login.php?redirect=" . wp_guess_url()) .
            '">here</a> to login.';
    }
}

function fhq_validate_comment_filter($comments){
	if($_SESSION['is_validate']){
		return $comments;
	}else{
		return array();	
	}
}



function fhq_generate_menu($menu)
{
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10 ) {
        return $menu;
    }

    $exclude_array = array();
    $page_array = get_pages();
    foreach ($page_array as $post) {
        $access_level = get_post_meta($post->ID, '_fhq_access_level', true);
        if ($access_level == 'PRIVATE') {
            $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
        } else {
            $privilege = '';
        }
        $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
        $period = get_post_meta($post->ID, '_fhq_delay_period', true);
        $unit = get_post_meta($post->ID, '	_fhq_delay_periodunit', true);
        if ($delaytype == "NONE") {
            $releasedate = 0;
        } else {
            $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
        }
		$isValidate = validate_access($_SESSION['memship'], $privilege, $delaytype, $period, $unit, $releasedate);
		if(get_post_meta($post->ID,'_fhq_pagetype',true)!="PROCESS" && get_post_meta($post->ID,'_fhq_pagetype',true)!="MEMSITE"){
			$isValidate = true;
		}else{
			if(get_post_meta($post->ID,'_fhq_hidden_menu',true) == true){
				$isValidate = false;
			}
		}
		
        if (!$isValidate) {
            $exclude_array[] = $post->ID;
        }
    }

    $html = str_get_html($menu);
    foreach ($exclude_array as $post_id) {
        $html->find('li.page-item-' . $post_id, 0)->outertext = '';
    }

    return $html;
}

if (is_admin()) {
    include_once "fusionpress_customfield.php";
}

include_once "simple_html_dom.php";

function fhq_validate_posts_action($posts){
    //echo $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	
    $page_url = $_SERVER['REQUEST_URI'];	
   
    
    global $current_user;
    get_currentuserinfo();
    if ($current_user->wp_user_level == 10) {
        $_SESSION['is_validate'] = true;
        //return $posts;
    }
   
    $_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);
	
	$postCount = count($posts);
	$invalidCount = 0;
	$validCount = 0;
	
	foreach($posts as $post){
		
	    $access_level = get_post_meta($post->ID, '_fhq_access_level', true);
	    if ($access_level == 'PRIVATE') {
		   $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
	    } else {
		   $privilege = '';
	    }
	    $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
	    $period = get_post_meta($post->ID, '_fhq_delay_period', true);
	    $unit = get_post_meta($post->ID, '_fhq_delay_periodunit', true);
	    if ($delaytype == "NONE") {
		   $releasedate = 0;
	    } else {
		   $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
	    }
	
	    $isValidate = validate_access($_SESSION['memship'], $privilege, $delaytype, $period, $unit, $releasedate);
	    if ($current_user->wp_user_level == 10) {
	    	   $isValidate = true;
	    }
		if(get_post_meta($post->ID,'_fhq_pagetype',true)!="PROCESS" && get_post_meta($post->ID,'_fhq_pagetype',true)!="MEMSITE"){
			$isValidate = true;
		}
		
	    
	    if (!$isValidate) {
		    $invalidCount = $invalidCount + 1;
		    $post->post_content = 'You do not have permission to view this content.<br>If you are a member please click <a href="' . (get_option
            ('siteurl') . "/" . "wp-login.php?redirect=" . wp_guess_url()) .
            '">here</a> to login.';
		    $post->comment_status = 'closed';
		    $post->ping_status    = 'closed';
			
			$validPosts[$validCount] = $post;
			$validCount++;
	    }else{
		    $validPosts[$validCount] = $post;
			
			/////////////// get P and M from [[PROTECTED]] tag ///////////////
			
			
			if(isset($_SESSION['fhq_unique_id'])){
				$fhq_unique_id = $_SESSION['fhq_unique_id'];
			}else{
				$fhq_unique_id = $_COOKIE['fhq_unique_id'];
			}
			
			//$post->post_content = "xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxxxxxxxxxxxxxxxx xxxxxxxxxxxxxxxxxxxx xxxxxx[[PROTECTED:p1555,m1331]] THIS IS PROTECTED CONTENT1.  [[/PROTECTED]]xxxxxxxxxxxx xxx xxxxxxxx xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxx";
			
			//$post->post_content .= "xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxxxxxxxxxxxxxxxx xxxxxxxxxxxxxxxxxxxx xxxxxx[[PROTECTED:p1555,m1346]] THIS IS PROTECTED CONTENT2.  [[/PROTECTED]]xxxxxxxxxxxx xxx xxxxxxxx xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxx xxxxxxxxxxxxxx xxxxxx";
			
			
			// TODO: retrieve P and M from tag.
			$pattern = "/\[\[PROTECTED:([pm,\d]+)\]\](.+?)\[\[\/PROTECTED\]\]/is";
				
			preg_match_all($pattern,$post->post_content,$matchs, PREG_PATTERN_ORDER);
				
			global $wpdb;	
			$result = $wpdb->get_row("Select product_list from ".$wpdb->prefix."fhq_unique where unique_id = '".$fhq_unique_id."' ");
			$product_lists = $result->product_list;
			$result = $wpdb->get_row("Select memlevel_list from ".$wpdb->prefix."fhq_unique where unique_id = '".$fhq_unique_id."' ");
			$memlevel_lists = $result->memlevel_list;
			
			$product_lists_array = set_to_array($product_lists, '|' );
			$memlevel_lists_array = set_to_array($memlevel_lists, '|' );
				
			for($i=0;$i<count($matchs[0]);$i++){
				$protectlevel = explode(",",$matchs[1][$i]);
					
				$protectcontent = $matchs[2][$i];
					
				$allow_content = false;
				for($j=0;$j<count($protectlevel);$j++){
					$type = substr($protectlevel[$j],0,1);
					$type_id = substr($protectlevel[$j],1,strlen($protectlevel[$j]));
					
					if($type == 'p'){
						$types['p'] = $type_id;	
					}else if($type == 'm'){
						$types['m'] = $type_id;
					}
				}
				
				//$result = $wpdb->get_row("Select product_list from ".$wpdb->prefix."_fhq_unique where unique_id = '".$fhq_unique_id."' ");
	
				if( (in_array($types['p'],$product_lists_array) || $types['p'] == '' ) && (in_array($types['m'],$memlevel_lists_array) || $types['m'] == '' ) ){
					$allow_content = true;	
				}
					
					
				if($allow_content){
					$post->post_content = str_replace($matchs[0][$i],$protectcontent,$post->post_content);
				}else{
					$post->post_content = str_replace($matchs[0][$i],"",$post->post_content);
				}
			}
				
				//$str_tmp = explode("[[/PROTECTED]]",$post->post_content);
				
			
			//////////////////////////////////////////////////////////////////
		    
		    if(get_post_meta($post->ID,'_fhq_pagetype',true)=="PROCESS"){
			    $res = explode('?',$page_url);
			    $res = pair_str_to_array($res[1], '=', '&');
			    if($res['e'] == '' || $res['v'] == ''){
				    $validPosts[$validCount]->post_content = "<font color='#F00'>This is encrypted content.</font>";
					$validPosts[$validCount]->comment_status = 'closed';
					$validPosts[$validCount]->ping_status    = 'closed';
			    }else{
				    $res = explode('?',$page_url);
				    $res = pair_str_to_array($res[1], '=', '&');
					
					#####################################################################
					#####################################################################
					$encrypted_string = urldecode($res["e"]);
					
					$encrypted_string = str_replace(" ","+",$encrypted_string);
					
					$validate_code = str_replace(" ","+",$res["v"]);
					
					$secretkey = get_option('fhq_process_secretkey');
					
					############ Decrypt secret key
					if(substr(md5("PP".$encrypted_string.$secretkey),0,8) == $validate_code) {
						$paramStr = decrypt($encrypted_string,$secretkey);
						$paramArr = pairstr2Arr($paramStr,"=","&");
						$paramArr[$mode] = $param[$mode];
						$paramArr['clunique'] = $unique;
			
						if(!isset($paramArr['pageid']) && isset($paramArr['p'])) $paramArr['pageid'] = custombase_convert_big($paramArr['p'],'BASE62','DEC');
						if(!isset($paramArr['from']) && isset($paramArr['n'])) $paramArr['from'] = custombase_convert_big($paramArr['n'],'BASE62','DEC');
						if(!isset($paramArr['fromsplit']) && isset($paramArr['f'])) $paramArr['fromsplit'] = $paramArr['f'];
						if(!isset($paramArr['split']) && isset($paramArr['s'])) $paramArr['split'] = $paramArr['s'];
						if(!isset($paramArr['link']) && isset($paramArr['l'])){
							switch($paramArr['l']){
								case 1: $paramArr['link'] = 'YES1';break;
								case 2: $paramArr['link'] = 'YES2';break;
								case 3: $paramArr['link'] = 'YES3';break;
								case 0: $paramArr['link'] = 'NO';break;
							 }
						}
						if(!isset($paramArr['product']) && isset($paramArr['d'])) $paramArr['product'] = custombase_convert_big($paramArr['d'],'BASE62','DEC');
						if(!isset($paramArr['paymentplan']) && isset($paramArr['m'])) $paramArr['paymentplan'] = custombase_convert_big($paramArr['m'],'BASE62','DEC');
						if(!isset($paramArr['node']) && isset($paramArr['n'])) $paramArr['node'] = custombase_convert_big($paramArr['n'],'BASE62','DEC');
						if(!isset($paramArr['next']) && isset($paramArr['p'])) $paramArr['next'] = custombase_convert_big($paramArr['p'],'BASE62','DEC');
						if(!isset($paramArr['cunique']) && isset($paramArr['u'])) $paramArr['cunique'] = $paramArr['u'];
						
						if($paramArr['split'] == 'A'){
							$validPosts[$validCount]->post_content = get_post_meta($validPosts[$validCount]->ID,'_content_a',true); 
						}else if($paramArr['split'] == 'B'){
							$validPosts[$validCount]->post_content = get_post_meta($validPosts[$validCount]->ID,'_content_b',true);
						}else{
							if(isset($_COOKIE['split'.$validPosts[$validCount]->ID])){
								if($_COOKIE['split'.$validPosts[$validCount]->ID] == "A"){
									$validPosts[$validCount]->post_content = get_post_meta($validPosts[$validCount]->ID,'_content_a',true); 
								}else{
									$validPosts[$validCount]->post_content = get_post_meta($validPosts[$validCount]->ID,'_content_b',true);
								}
							}else{
								if(rand(0,100) < 50){
									$validPosts[$validCount]->post_content = get_post_meta($validPosts[$validCount]->ID,'_content_a',true); 
									setcookie('split'.$validPosts[$validCount]->ID, "A", time()+3600*24*30*36);
								}else{
									$validPosts[$validCount]->post_content = get_post_meta($validPosts[$validCount]->ID,'_content_b',true);
									setcookie('split'.$validPosts[$validCount]->ID, "B", time()+3600*24*30*36);
								}	
							}
							
						}
						
						
					} else {
						$validPosts[$validCount]->post_content = "<font color='#F00'>This is encrypted content.</font>";
					}
					#####################################################################
					#####################################################################
					
			    }
		    }
		    $validCount++;	    
	    }
		
		$_SESSION['is_validate'] = $isValidate;
	}
	
	if($invalidCount <= $postCount){
		return $validPosts;
	}else{
		$invalidPosts[0] = $posts[0];
		$invalidPosts[0]->post_author = "1";
		$invalidPosts[0]->post_date = date("Y-m-d H:i:s");
		$invalidPosts[0]->post_title = "Forbidden content";
		$invalidPosts[0]->post_name = "";
		$invalidPosts[0]->post_content = 'You do not have permission to view this content.<br>If you are a member please click <a href="' . (get_option
            ('siteurl') . "/" . "wp-login.php?redirect=" . wp_guess_url()) .
             '">here</a> to login.';
		return $invalidPosts;
	}
}

function fhq_generate_category_list($arg){
	global $current_user;
     get_currentuserinfo();
	if($current_user->wp_user_level == 10){
		return $arg;
	}
	
	$_SESSION['memship'] = get_user_meta($current_user->id, "_fhq_memship", true);
	
	global $wpdb;
	
	$categories = $wpdb->get_results("select wp_terms.name , wp_terms.slug from wp_terms , wp_term_taxonomy 
						   where wp_terms.term_id = wp_term_taxonomy.term_id 
						   and wp_term_taxonomy.taxonomy = 'category' 
						   and wp_term_taxonomy.count <> '0' ");

	$arg = "<ul>";
	foreach($categories as $cat){
		$cat_count= 0;
		$posts = $wpdb->get_results("select * from wp_posts , wp_term_relationships , wp_terms , wp_term_taxonomy 
								  where wp_posts.post_status = 'publish' 
								  and wp_posts.ID = wp_term_relationships.object_id 
								  and wp_term_relationships.term_taxonomy_id = wp_term_taxonomy.term_taxonomy_id
								  and wp_term_taxonomy.term_id = wp_terms.term_id
								  and wp_terms.name = '".$cat->name."' ");
		foreach($posts as $post){
			$access_level = get_post_meta($post->ID, '_fhq_access_level', true);
		     if ($access_level == 'PRIVATE') {
			    $privilege = get_post_meta($post->ID, '_fhq_protectedfor', true);
		     } else {
			    $privilege = '';
		     }
		     $delaytype = get_post_meta($post->ID, '_fhq_delay_type', true);
		     $period = get_post_meta($post->ID, '_fhq_delay_period', true);
		     $unit = get_post_meta($post->ID, '_fhq_delay_periodunit', true);
		     if ($delaytype == "NONE") {
		  	    $releasedate = 0;
		     } else {
			    $releasedate = get_post_meta($post->ID, '_fhq_delay_releasedate', true);
		     }
			$isValidate = validate_access($_SESSION['memship'], $privilege, $delaytype, $period, $unit, $releasedate);
			if($isValidate == true){
				$cat_count++;
			}
		}
		if($cat_count!=0){
			$path = home_url()."/category/".$cat->slug;
			$arg .= "<li><a href='".$path."'>".$cat->name." (".$cat_count.")</a></li>"; 
		}
	}
	$arg .= "</ul>";
	
	return $arg;
}

function fhq_xmlrpc_methods($methods){
	$methods['wp-fhq.getCategoryByID'] = 'fhq_getCategoryByID_function';
	$methods['wp-fhq.updateCategory'] = 'fhq_updateCategory_function';
	$methods['wp-fhq.savePostMeta'] = 'fhq_savePostMeta_function';
	$methods['wp-fhq.updateMemsiteList'] = 'fhq_updateMemsiteList_function';
	$methods['wp-fhq.updateProcessList'] = 'fhq_updateProcessList_function';
	$methods['wp-fhq.fhq_updateAttachment'] = 'fhq_updateAttachment_function';
	$methods['wp-fhq.fhq_updateUnique'] = 'fhq_updateUnique_function';
	return $methods;
}

function fhq_getCategoryByID_function($args){
	// Parse the arguments, assuming they're in the correct order
	$blog_id				= (int) $args[0];
	$username				= $args[1];
	$password				= $args[2];
	$category_id			= (int) $args[3];
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	$res_cat = get_term($category_id,'category');

	return $res_cat;
}

function fhq_updateCategory_function($args){
	// Parse the arguments, assuming they're in the correct order
	$blog_id				= (int) $args[0];
	$username				= $args[1];
	$password				= $args[2];
	$category_id			= (int) $args[3];
	$update_args			= $args[4];
	
	//return $update_args;
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	// Make sure the user is allowed to add a category.
	if ( !current_user_can("manage_categories") )
		return(new IXR_Error(401, __("Sorry, you do not have the right to add a category.")));
	
	if($update_args['id']!=""){
		global $wpdb;
		$wpdb->update( 'wp_terms', array( 'term_id' => $update_args['id']), array( 'term_id' => $category_id ), array( '%d' ), array( '%d' ) );
		$wpdb->update( 'wp_term_taxonomy', array( 'term_id' => $update_args['id']), array( 'term_id' => $category_id ), array( '%d' ), array( '%d' ) );
	}else{
		wp_update_term( $category_id, 'category', $update_args );
	}
	
	return true;
	
}

function fhq_savePostMeta_function($args){
	$blog_id			= (int) $arg[0];
	$username			= $args[1];
	$password			= $args[2];
	$pagetype			= $args[3];
	$post_id			= (int) $args[4];
	$content_a		= $args[5];
	$content_b		= $args[6];
	$node_id			= (int) $args[7];
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	if($pagetype == "PROCESS"){
		update_post_meta($post_id,'_fhq_pagetype',"PROCESS");
		update_post_meta($post_id,'_content_a',$content_a);
		update_post_meta($post_id,'_content_b',$content_b);
	}else{
		update_post_meta($post_id,'_fhq_pagetype',"MEMSITE");
	}
	update_post_meta($post_id,'_fhq_node_id',$node_id);
	
	return true;
	
}

function fhq_updateMemsiteList_function($args){
	$blog_id			= (int) $arg[0];
	$username			= $args[1];
	$password			= $args[2];
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	$fhq_account = get_option('fhq_account');
	$fhq_apikey = get_option('fhq_apikey');
	$returnvar = fhq_server_request($fhq_account, $fhq_apikey, "memsite_list", array('hosting' => 'WORDPRESS'));
	if ($returnvar->success) {
		$memsiteArray = array();
		foreach ($returnvar->result as $val) {
			$id = $val->id;
			$memsiteArray[$id]['name'] = $val->name;
		}
		$json = json_encode($memsiteArray);
		update_option('fhq_memsite', $json);
	}
	
	return true;
}

function fhq_updateProcessList_function($args){
	$blog_id			= (int) $arg[0];
	$username			= $args[1];
	$password			= $args[2];
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	$fhq_account = get_option('fhq_account');
	$fhq_apikey = get_option('fhq_apikey');
	$returnvar = fhq_server_request($fhq_account, $fhq_apikey, "process_list", array('hosting' => 'WORDPRESS'));
	if ($returnvar->success) {
		$memsiteArray = array();
		foreach ($returnvar->result as $val) {
			$id = $val->id;
			$memsiteArray[$id]['name'] = $val->name;
		}
		$json = json_encode($memsiteArray);
		update_option('fhq_process', $json);
	}
	
	return true;
}

function fhq_updateAttachment_function($args){
	$blog_id			= (int) $arg[0];
	$username			= $args[1];
	$password			= $args[2];
	$attachment_name	= $args[3];
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	global $wpdb;
	
	$text = explode('--',$attachment_name);
	
	$attachment_name = $text[0]."-".$text[1];
	
	$posts = $wpdb->get_results("SELECT * FROM wp_posts WHERE post_title = 'wpid-".$attachment_name."' and post_type = 'attachment' ");
	
	foreach($posts as $post){
		$post_url = $post->guid;
		wp_delete_post($post->ID,true);
	}
	
	return $post_url;
}

function fhq_updateUnique_function($args){
	$blog_id			= (int) $arg[0];
	$username			= $args[1];
	$password			= $args[2];
	$unique				= $args[3];
	
	global $wp_xmlrpc_server;
	
	$wp_xmlrpc_server->escape($args);

	// Let's run a check to see if credentials are okay
	if ( !$user = $wp_xmlrpc_server->login($username, $password) ) {
		return $wp_xmlrpc_server->error;
	}
	
	global $wpdb;
	
	$result = $wpdb->get_row("Select * from ".$wpdb->prefix."fhq_unique where unique_id = '".$unique["unique_id"]."' ");
	
	if($result != NULL){
		if($result->email_list != ""){
			$email_array = set_to_array($result->email_list, '|' );
			if(!in_array($unique["email"],$email_array)){
				$email_list = $result->email_list."|".$unique["email"];	
			}else{
				$email_list = $result->email_list;
			}
		}else{
			$email_list = $unique["email"];
		}
		if($result->transaction_list != ""){
			$transaction_array = set_to_array($result->transaction_list, '|' );
			if(!in_array($unique["current_transaction"],$transaction_array)){
				$transaction_list = $result->transaction_list."|".$unique["current_transaction"];	
			}else{
				$transaction_list = $result->transaction_list;
			}
		}else{
			$transaction_list = $unique["current_transaction"];
		}
		if($result->product_list != ""){
			$product_list = $result->product_list;
			$product_array = set_to_array($product_list, '|' );
			$unique_product_array = set_to_array($unique["product"] , '|');
			for($i=0;$i<count($unique_product_array);$i++){
				if(!in_array($unique_product_array[$i],$product_array)){
					$product_list .= "|".$unique_product_array[$i];	
				}
			}
		}else{
			$product_list = $unique["product"];
		}
		$wpdb->update( 
			'wp_fhq_unique', 
			array( 
					'first_name' 			=> $unique["first_name"],
					'last_name' 			=> $unique["last_name"],
					'email' 				=> $unique["email"],
					'email_list' 			=> $email_list,
					'current_transaction' 	=> $unique["current_transaction"],
					'transaction_list' 		=> $transaction_list,
					'product_list' 			=> $product_list					
			), 
			array( 'unique_id' => $unique["unique_id"] ), 
			array( '%s', '%s', '%s', '%s', '%s', '%s', '%s' ), 
			array( '%s' ) 
		);
		return true;
	}else{
		$wpdb->insert( 
			'wp_fhq_unique', 
			array(  'unique_id' 			=> $unique["unique_id"],
					'first_name' 			=> $unique["first_name"],
					'last_name' 			=> $unique["last_name"],
					'email' 				=> $unique["email"],
					'email_list' 			=> $unique["email"],
					'current_transaction' 	=> $unique["current_transaction"],
					'transaction_list' 		=> $unique["current_transaction"],
					'product_list' 			=> $unique["product"]	
			), 
			array( '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s' ) 
		);
	}	
	
}

function updateUniqueMemlevelList($unique_id,$memlevel){
	
	global $wpdb;
	$result = $wpdb->get_row("Select * from ".$wpdb->prefix."fhq_unique where unique_id = '".$unique_id."' ");
	if($result != NULL){
		if($result->memlevel_list != ""){
			$memlevel_array = set_to_array($result->memlevel_list, '|' );
			if(!in_array($memlevel,$memlevel_array)){
				$memlevel_list = $result->memlevel_list."|".$memlevel;	
			}else{
				$memlevel_list = $result->memlevel_list;
			}
		}else{
			$memlevel_list = $memlevel;
		}
		$wpdb->update( 
			'wp_fhq_unique', 
			array( 
					'memlevel_list' 			=> $memlevel_list					
			), 
			array( 'unique_id' => $unique_id ), 
			array( '%s' ), 
			array( '%s' ) 
		);
		return true;
	}else{
		echo "null";
		$wpdb->insert( 
			'wp_fhq_unique', 
			array(  'unique_id' 			=> $unique_id,
					'memlevel_list' 		=> $memlevel	
			), 
			array( '%s', '%s' ) 
		);
	}	
}

/*
function tinyplugin_add_button($buttons)
{
    $page_url = $_SERVER['REQUEST_URI'];	
    $res = explode('?',$page_url);
    $res = pair_str_to_array($res[1], '=', '&');
    $page_id = $res['post'];
    
    if(get_post_meta($page_id,'_fhq_pagetype',true)=="PROCESS" && get_post_meta($page_id,'_content_b',true)!=""){
    		array_push($buttons, "separator", "viewcontentA", "viewcontentB");
    }
    return $buttons;
}

function tinyplugin_register($plugin_array)
{
    $plugindir = WP_PLUGIN_URL . '/' . str_replace(basename(__file__), "", plugin_basename(__file__));
    $url = $plugindir."js/fusionpress_mcebutton.js";
 
    $plugin_array["tinyplugin"] = $url;
    return $plugin_array;
}
*/
function tinyplugin_init($init_array){
	$page_url = $_SERVER['REQUEST_URI'];	
	$res = explode('?',$page_url);
	$res = pair_str_to_array($res[1], '=', '&');
	$page_id = $res['post'];
	
	if(get_post_meta($page_id,'_fhq_pagetype',true)=="PROCESS"){
		$init_array['readonly'] = true;
	}

	return $init_array;	
}

function disable_htmleditor() {
	if(get_post_meta($page_id,'_fhq_pagetype',true)=="PROCESS"){
		echo '<style type="text/css">#editor-toolbar #edButtonHTML, #quicktags {display: none;}</style>' . "\n";
	}
}


function fhq_validate_editor_filter($content){
	$page_url = $_SERVER['REQUEST_URI'];	
	$res = explode('?',$page_url);
	$res = pair_str_to_array($res[1], '=', '&');
	$page_id = $res['post'];
	
	if(get_post_meta($page_id,'_fhq_pagetype',true)=="PROCESS"){
		$content = '<textarea id="content" name="content" tabindex="2" cols="40" rows="30" readonly="true">Please edit this content in <a href="http://www.fusionhq.com">FusionHQ</a>.</textarea>';
	}
	return $content;
}

function fhq_initscript(){
	$plugindir = WP_PLUGIN_URL . '/' . str_replace(basename(__file__), "", plugin_basename(__file__));

		//wp_deregister_script( 'jquery' );
		//wp_deregister_script( 'jquery-form' );
		//wp_deregister_script( 'jquery-ui-core' );
		//wp_deregister_script( 'jquery-datepicker' );
		//wp_deregister_script( 'fusionhq-customfield-script' );
		
		//wp_register_script('jquery-datepicker', $plugindir . 'js/ui.datepicker.min.js');
		wp_register_script('fusionhq-customfield-script', $plugindir . 'fusionpress_customfield.js');
		
		wp_deregister_script('jquery-ui');
		wp_register_script('jquery-ui', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.7/jquery-ui.min.js', array('jquery'), '1.8.7');
		
		wp_enqueue_script("jquery");
		wp_enqueue_script("jquery-ui");
		wp_enqueue_script("jquery-form");
		//wp_enqueue_script("jquery-ui-core");
		//wp_enqueue_script("jquery-ui-dialog");
		//wp_enqueue_script('jquery-datepicker');
		wp_enqueue_script('fusionhq-customfield-script');
		
}

function fhq_initstyle(){
	$plugindir = WP_PLUGIN_URL . '/' . str_replace(basename(__file__), "", plugin_basename(__file__));

	wp_register_style('fhq-wordpress', $plugindir . 'css/wordpress.css');
	wp_enqueue_style('fhq-wordpress');	
	wp_register_style('jquery-ui-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/smoothness/jquery-ui.css');
	wp_enqueue_style('jquery-ui-style');
	
}

function fhq_admin_initstyle(){
	$plugindir = WP_PLUGIN_URL . '/' . str_replace(basename(__file__), "", plugin_basename(__file__));

	wp_register_style('fhq-wordpress', $plugindir . 'css/wordpress.css');
	wp_enqueue_style('fhq-wordpress');	
	wp_register_style('jquery-ui-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/smoothness/jquery-ui.css');
	wp_enqueue_style('jquery-ui-style');
	//wp_register_style('jquery-datepicker', $plugindir . 'css/jquery-ui.css');
	//wp_enqueue_style('jquery-datepicker');
}


// add this plugin to administration menu
add_action('plugins_loaded', 'fhq_session_init');
add_action('admin_menu', 'fhq_plugins_menu');
add_action('admin_notices', 'fhq_admin_warnings');
add_action('wp_print_scripts', 'fhq_initscript');
add_action('wp_print_styles', 'fhq_initstyle');
add_action('admin_print_styles', 'fhq_admin_initstyle');
add_action('init', 'fhq_unique_indentification');

add_filter('wp_authenticate', 'fhq_user_login');
add_filter('wp_redirect', 'fhq_force_redirect');
add_action('login_form', 'fhq_save_redirect');
add_action('wp_logout', 'fhq_session_destroy');

//add_action('the_post', 'fhq_post_action', 1, 2);
add_filter('the_posts', 'fhq_validate_posts_action', 1, 2);

add_filter('the_editor', 'fhq_validate_editor_filter');
add_filter('the_content', 'fhq_validate_access_filter', 1, 2);
add_filter('comments_array', 'fhq_validate_comment_filter', 1, 2);
add_filter('wp_list_pages', 'fhq_generate_menu', 1, 2);
add_filter('wp_list_categories','fhq_generate_category_list');

add_filter('xmlrpc_methods','fhq_xmlrpc_methods');

//add_filter('mce_external_plugins', "tinyplugin_register");
//add_filter('mce_buttons', 'tinyplugin_add_button', 0);
add_filter('tiny_mce_before_init', 'tinyplugin_init', 0);

add_filter( 'wp_default_editor', create_function('', 'return "tinymce";') );
add_action( 'admin_head', 'disable_htmleditor' );


?>